
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Performance_reviewsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const performance_reviews = await db.performance_reviews.create(
            {
                id: data.id || undefined,
        
        review_date: data.review_date
        ||
        null
            ,
            
        score: data.score
        ||
        null
            ,
            
        summary: data.summary
        ||
        null
            ,
            
        goals: data.goals
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await performance_reviews.setEmployee( data.employee || null, {
            transaction,
        });
        
        await performance_reviews.setReviewer( data.reviewer || null, {
            transaction,
        });
        
        await performance_reviews.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return performance_reviews;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const performance_reviewsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                review_date: item.review_date
            ||
            null
            ,
            
                score: item.score
            ||
            null
            ,
            
                summary: item.summary
            ||
            null
            ,
            
                goals: item.goals
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const performance_reviews = await db.performance_reviews.bulkCreate(performance_reviewsData, { transaction });

        // For each item created, replace relation files
        

        return performance_reviews;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const performance_reviews = await db.performance_reviews.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.review_date !== undefined) updatePayload.review_date = data.review_date;
        
        
        if (data.score !== undefined) updatePayload.score = data.score;
        
        
        if (data.summary !== undefined) updatePayload.summary = data.summary;
        
        
        if (data.goals !== undefined) updatePayload.goals = data.goals;
        
        
        updatePayload.updatedById = currentUser.id;

        await performance_reviews.update(updatePayload, {transaction});

        
        
        if (data.employee !== undefined) {
            await performance_reviews.setEmployee(
              
              data.employee,
              
              { transaction }
            );
        }
        
        if (data.reviewer !== undefined) {
            await performance_reviews.setReviewer(
              
              data.reviewer,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await performance_reviews.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return performance_reviews;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const performance_reviews = await db.performance_reviews.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of performance_reviews) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of performance_reviews) {
                await record.destroy({transaction});
            }
        });


        return performance_reviews;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const performance_reviews = await db.performance_reviews.findByPk(id, options);

        await performance_reviews.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await performance_reviews.destroy({
            transaction
        });

        return performance_reviews;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const performance_reviews = await db.performance_reviews.findOne(
            { where },
            { transaction },
        );

        if (!performance_reviews) {
            return performance_reviews;
        }

        const output = performance_reviews.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.employee = await performance_reviews.getEmployee({
            transaction
        });
        
        
        output.reviewer = await performance_reviews.getReviewer({
            transaction
        });
        
        
        output.organizations = await performance_reviews.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.employees,
        as: 'employee',
        
        where: filter.employee ? {
          [Op.or]: [
            { id: { [Op.in]: filter.employee.split('|').map(term => Utils.uuid(term)) } },
            {
              employee_number: {
                [Op.or]: filter.employee.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'reviewer',
        
        where: filter.reviewer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.reviewer.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.reviewer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.summary) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'performance_reviews',
                        'summary',
                        filter.summary,
                    ),
                };
            }
            
            if (filter.goals) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'performance_reviews',
                        'goals',
                        filter.goals,
                    ),
                };
            }
            

            
            

            
            if (filter.review_dateRange) {
                const [start, end] = filter.review_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    review_date: {
                    ...where.review_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    review_date: {
                    ...where.review_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.scoreRange) {
                const [start, end] = filter.scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.performance_reviews.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'performance_reviews',
                        'summary',
                        query,
                    ),
                ],
            };
        }

        const records = await db.performance_reviews.findAll({
            attributes: [ 'id', 'summary' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['summary', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.summary,
        }));
    }

    
};

